//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;
#define int long long
//#pragma GCC optimize("O3,unroll-loops")
//#pragma GCC target("avx2")

constexpr int mod = 998244353;
int st(int x,int n)
{
    if (n==0) return x%mod;
    int a = st(x,n-1);
    return ((a*a)%mod+mod)%mod;
}
int get_st(int x,int n)
{
    int ans=1;
    for (int i=30;i>=0;i--)
    {
        if ((1<<i)<=n)
        {
            int a = st(x,i);
            n -= (1<<i);
            ans = ((ans*a)%mod+mod)%mod;
        }
    }
    return ans;
}
vector<int> ans,v;
signed main()
{
    int n,q;
    cin >> n >> q;
    v.resize(n);
    ans.resize(n);
    for (int i=0;i<n;i++) cin >> v[i];
    for (int i=0;i<n;i++) v[i]--;
    vector<int> v1,v2;
    for (int i=0;i<n;i++)
    {
        if (v[i]==1) v1.push_back(i);
        if (v[i]==2) v2.push_back(i);
    }
    for (int i=0;i<n;i++)
    {
        if (v[i]==1)
        {
            ans[i] = lower_bound(v1.begin(),v1.end(),i)-v1.begin();
        }
        else
        {
            ans[i] = lower_bound(v2.begin(),v2.end(),i)-v2.begin();
        }
    }
    for (int i=0;i<q;i++)
    {
        int t;
        cin >> t;
        if (t==1)
        {
            int x;
            cin >> x;
            x--;
            swap(v[x],v[x+1]);
            if (v[x]!=v[x+1]) swap(ans[x],ans[x+1]);
        }
        if (t==2)
        {
            int y;
            cin >> y;
            cout << ans[y] << "\n";
        }
    }
}
